FilterValve (Apache Tomcat 11.0.23 API Documentation)
Description: declaration: package: org.apache.catalina.valves, class: FilterValve

# Class FilterValve

java.lang.Object
org.apache.catalina.util.LifecycleBase
org.apache.catalina.util.LifecycleMBeanBase
org.apache.catalina.valves.ValveBase
org.apache.catalina.valves.FilterValve

All Implemented Interfaces:
  `FilterConfig, MBeanRegistration, Contained, JmxEnabled, Lifecycle, Valve`

public class FilterValve extends ValveBase implements FilterConfig

A Valve to wrap a Filter, allowing a user to run Servlet Filters as a part of the Valve chain.

There are some caveats you must be aware of when using this Valve to wrap a Filter:

- You get a separate instance of your Filter class distinct from any that may be instantiated within your application.
- Calls to `FilterConfig.getFilterName()` will return `null`.
- Calling `FilterConfig.getServletContext()` will return the proper ServletContext for a Valve/Filter attached to a `<Context>`, but will return a ServletContext which is nearly useless for any Valve/Filter specified on an `<Engine>` or `>Host<`.
- Your Filter MUST NOT wrap the `ServletRequest` or `ServletResponse` objects, or an exception will be thrown.

See Also:
  - `Valve`
  - `Filter`

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface Lifecycle

  `Lifecycle.SingleUse`

- ## Field Summary

  ### Fields inherited from class ValveBase

  `asyncSupported, container, containerLog, next, sm`

  ### Fields inherited from interface Lifecycle

  `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FilterValve()`
  Creates a new FilterValve instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addInitParam(String paramName, String paramValue)`
  Adds an initialization parameter for the Filter.
  `String`
  `getFilterClassName()`
  Gets the name of the class for the Filter.
  `String`
  `getFilterName()`
  Get the name of the filter.
  `String`
  `getInitParameter(String name)`
  Returns a `String` containing the value of the named initialization parameter, or `null` if the parameter does not exist.
  `Enumeration<String>`
  `getInitParameterNames()`
  Returns the names of the filter's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the filter has no initialization parameters.
  `ServletContext`
  `getServletContext()`
  Returns a reference to the `ServletContext` in which the caller is executing.
  `void`
  `invoke(Request request, Response response)`
  Perform request processing as required by this Valve.
  `void`
  `setFilterClass(String filterClassName)`
  Sets the name of the class for the Filter.
  `void`
  `setFilterClassName(String filterClassName)`
  Sets the name of the class for the Filter.
  `protected void`
  `startInternal()`
  Start this component and implement the requirements of `LifecycleBase.startInternal()`.
  `protected void`
  `stopInternal()`
  Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.

  ### Methods inherited from class ValveBase

  `backgroundProcess, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, toString`

  ### Methods inherited from class LifecycleMBeanBase

  `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

  ### Methods inherited from class LifecycleBase

  `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### FilterValve

    public FilterValve()
    Creates a new FilterValve instance.

- ## Method Details

  - ### setFilterClass

    public void setFilterClass(String filterClassName)
    Sets the name of the class for the Filter.
    Parameters:
      `filterClassName` - The class name for the Filter.

  - ### setFilterClassName

    public void setFilterClassName(String filterClassName)
    Sets the name of the class for the Filter.
    Parameters:
      `filterClassName` - The class name for the Filter.

  - ### getFilterClassName

    public String getFilterClassName()
    Gets the name of the class for the Filter.
    Returns:
      The class name for the Filter.

  - ### addInitParam

    public void addInitParam(String paramName, String paramValue)
    Adds an initialization parameter for the Filter.
    Parameters:
      `paramName` - The name of the parameter.
      `paramValue` - The value of the parameter.

  - ### getFilterName

    public String getFilterName()
    Description copied from interface: `jakarta.servlet.FilterConfig`
    Get the name of the filter.
    Specified by:
      `getFilterName` in interface `FilterConfig`
    Returns:
      `null`

  - ### getServletContext

    public ServletContext getServletContext()
    Description copied from interface: `jakarta.servlet.FilterConfig`
    Returns a reference to the `ServletContext` in which the caller is executing.
    Specified by:
      `getServletContext` in interface `FilterConfig`
    Returns:
      the ServletContext. Note that this will be of limited use if the Valve/Filter is not attached to a `<Context>`.
    See Also:
      - `ServletContext`

  - ### getInitParameter

    public String getInitParameter(String name)
    Description copied from interface: `jakarta.servlet.FilterConfig`
    Returns a `String` containing the value of the named initialization parameter, or `null` if the parameter does not exist.
    Specified by:
      `getInitParameter` in interface `FilterConfig`
    Parameters:
      `name` - `String` specifying the name of the initialization parameter
    Returns:
      `String` containing the value of the initialization parameter

  - ### getInitParameterNames

    public Enumeration<String> getInitParameterNames()
    Description copied from interface: `jakarta.servlet.FilterConfig`
    Returns the names of the filter's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the filter has no initialization parameters.
    Specified by:
      `getInitParameterNames` in interface `FilterConfig`
    Returns:
      `Enumeration` of `String` objects containing the names of the filter's initialization parameters

  - ### startInternal

    protected void startInternal() throws LifecycleException
    Description copied from class: `ValveBase`
    Start this component and implement the requirements of `LifecycleBase.startInternal()`.
    Overrides:
      `startInternal` in class `ValveBase`
    Throws:
      `LifecycleException` - if this component detects a fatal error that prevents this component from being used

  - ### stopInternal

    protected void stopInternal() throws LifecycleException
    Description copied from class: `ValveBase`
    Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.
    Overrides:
      `stopInternal` in class `ValveBase`
    Throws:
      `LifecycleException` - if this component detects a fatal error that prevents this component from being used

  - ### invoke

    public void invoke(Request request, Response response) throws IOException, ServletException
    Description copied from interface: `Valve`

    Perform request processing as required by this Valve.

    An individual Valve MAY perform the following actions, in the specified order:

    - Examine and/or modify the properties of the specified Request and Response.
    - Examine the properties of the specified Request, completely generate the corresponding Response, and return control to the caller.
    - Examine the properties of the specified Request and Response, wrap either or both of these objects to supplement their functionality, and pass them on.
    - If the corresponding Response was not generated (and control was not returned), call the next Valve in the pipeline (if there is one) by executing `getNext().invoke()`.
    - Examine, but not modify, the properties of the resulting Response (which was created by a subsequently invoked Valve or Container).

    A Valve MUST NOT do any of the following things:

    - Change request properties that have already been used to direct the flow of processing control for this request (for instance, trying to change the virtual host to which a Request should be sent from a pipeline attached to a Host or Context in the standard implementation).
    - Create a completed Response AND pass this Request and Response on to the next Valve in the pipeline.
    - Consume bytes from the input stream associated with the Request, unless it is completely generating the response, or wrapping the request before passing it on.
    - Modify the HTTP headers included with the Response after the `getNext().invoke()` method has returned.
    - Perform any actions on the output stream associated with the specified Response after the `getNext().invoke()` method has returned.
    Specified by:
      `invoke` in interface `Valve`
    Parameters:
      `request` - The servlet request to be processed
      `response` - The servlet response to be created
    Throws:
      `IOException` - if an input/output error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet
      `ServletException` - if a servlet error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet